<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch"
            label-width="80px">
            <el-form-item :label="tLang('device', '类型名称')" prop="name">
                <el-input v-model="queryParams.name"
                    :placeholder="tLang('common', '请输入') + tLang('device', '类型名称')" clearable
                    @keyup.enter="handleQuery" />
            </el-form-item>
            
            <el-form-item>
                <el-button type="primary" icon="search" size="mini"
                    @click="handleQuery">{{ tLang('common', '搜索') }}</el-button>
                <el-button icon="refresh" size="mini" @click="resetQuery">{{ tLang('common', '重置') }}</el-button>
            </el-form-item>
        </el-form>
        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button type="primary" plain icon="plus" size="mini" @click="handleAdd"
                    v-hasPermi="['pms:devType:add']">{{ tLang('common', '新增') }}</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button type="success" plain icon="edit" size="mini" :disabled="single" @click="handleUpdate"
                    v-hasPermi="['pms:devType:edit']">{{ tLang('common', '修改') }}</el-button>
            </el-col>
            <el-col :span="1.5">
                <el-button type="danger" plain icon="delete" size="mini" :disabled="multiple" @click="handleDelete"
                    v-hasPermi="['pms:devType:remove']">{{ tLang('common', '删除') }}</el-button>
            </el-col>
            <!-- <el-col :span="1.5">
          <el-button type="warning" plain icon="download" size="mini" @click="handleExport"
            v-hasPermi="['product:product:export']">导出</el-button>
        </el-col> -->
            <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
        </el-row>
        <el-table v-loading="loading" :data="deviceTypeList" @selection-change="handleSelectionChange">
            <el-table-column type="selection" width="55" align="center" />
            <el-table-column type="index" :label="tLang('common', '序号')" width="60" align="center" />
            <el-table-column :label="tLang('device', '类型名称')" v-if="columns[0].visible" align="center"
                prop="name" />
            <el-table-column :label="tLang('common', '操作')" align="center" class-name="small-padding fixed-width">
                <template #default="scope">
                    <el-tooltip :content="tLang('common', '修改')" placement="top" v-if="scope.row.userId !== 1">
                        <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
                            v-hasPermi="['pms:devType:edit']"></el-button>
                    </el-tooltip>
                    <el-tooltip :content="tLang('common', '删除')" placement="top" v-if="scope.row.userId !== 1">
                        <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
                            v-hasPermi="['pms:devType:remove']"></el-button>
                    </el-tooltip>
                </template>
            </el-table-column>
        </el-table>

        <div class="pagination">
            <el-pagination :hide-on-single-page="true" v-model:current-page="queryParams.pageNum"
                v-model:page-size="queryParams.pageSize" :page-sizes="[25, 50, 100, 150]"
                layout="total, sizes, prev, pager, next, jumper" :total="total" @size-change="getList"
                @current-change="getList" />
        </div>
        <AddEdit :title="title" v-model="open" :form="form" @submitForm="submitForm"></AddEdit>

    </div>
</template>

<script setup>
import { ref, reactive, watch, onMounted } from 'vue'
import { listDeviceType, getDeviceType, addDeviceType, updateDeviceType, delDeviceType } from "@/api/pms/device";
import AddEdit from './add_edit.vue';
const { proxy } = getCurrentInstance();

// 遮罩层
let loading = ref(true)
// 选中数组
let ids = ref([])
// 非单个禁用
let single = ref(true)
// 非多个禁用
let multiple = ref(true)
// 显示搜索条件
let showSearch = ref(false)
// 表单参数
let form = ref({})
// 是否显示弹出层
let open = ref(false)
// 弹出层标题
let title = ref("")
// 查询参数
let queryParams = reactive({
    pageNum: 1,
    pageSize: 10,
    name: null,
})

let total = ref(0)
// 设备信息表格数据
let deviceTypeList = ref([
    { name: '设备1', code: 'code1', id: 1 },
])
// 列显隐信息
const columns = ref([
    { key: 0, label: proxy.tLang('produce', '类型名称'), visible: true },
]);

const infoDialog = ref(false)
let produceinfo = ref({})
/** 查询设备信息列表 */
function getList() {
    loading.value = true;
    listDeviceType(queryParams).then(response => {
        deviceTypeList.value = response.rows;
        total.value = response.total;
        loading.value = false;
    });
}
// 多选框选中数据
function handleSelectionChange(selection) {
    ids.value = selection.map(item => item.code)
    single.value = selection.length !== 1
    multiple.value = !selection.length
}

//** 搜索按钮操作 */
function handleQuery() {
    queryParams.pageNum = 1;
    getList();
}
/** 重置按钮操作 */
function resetQuery() {
    queryParams.pageNum = 1
    queryParams.pageSize = 10
    queryParams.name = null

    handleQuery();
}
/** 新增按钮操作 */
function handleAdd() {
    reset();
    open.value = true;
    title.value = proxy.tLang('common', '添加') + ' ' + proxy.tLang('device', '设备配置');
}

/** 提交按钮 */
function submitForm(propform) {
        form.value.defalutConfig = form.value.defalutConfig&&form.value.defalutConfig.length >0?form.value.defalutConfig.join(','):null;
    if (propform.code != null) {
        updateDeviceType(form.value).then(response => {
            proxy.$modal.msgSuccess(proxy.tLang('common', '修改成功'));
            open.value = false;
            getList();
        });
    } else {
        addDeviceType(form.value).then(response => {
            proxy.$modal.msgSuccess(proxy.tLang('common', '新增成功'));
            open.value = false;
            getList();
        });
    }
}

// 取消按钮
function cancel() {
    open.value = false;
    reset();
}
// 表单重置
function reset() {
    form.value = {
        code: null,
        name: null,
        defalutConfig: null,
    };
    //resetForm("form");
}


/** 修改按钮操作 */
function handleUpdate(row) {
    reset();
    const id = row.code || ids.value
    getDeviceType(id).then(response => {
        form.value = response.data;
        if (form.value.defalutConfig) {
            form.value.defalutConfig = response.data.defalutConfig.split(",");
        } else {
            form.value.defalutConfig = []
        }
        
        open.value = true;
        title.value = proxy.tLang('common', '修改') + ' ' + proxy.tLang('device', '设备配置');
    });
}

/** 删除按钮操作 */
function handleDelete(row) {
    const id = row.code || ids.value;
    proxy.$modal.confirm(proxy.tLang('tip', '确定删除选中记录？') + ` [${id}]`).then(function () {
        return delDeviceType(id);
    }).then(() => {
        getList();
        proxy.$modal.msgSuccess(proxy.tLang('common', '删除成功'));
    }).catch(() => { });
}
onMounted(() => {
    getList();
})
</script>

<style lang="scss" scoped>
.pagination {
    width: 100%;
    margin: 10px;
    display: flex;
    justify-content: center;
    align-items: center;
}
</style>